欢迎来到PJCK的博客

(双指针 二分) leetcode 167. Two Sum II - Input array is sorted

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

Note:

  • Your returned answers (both index1 and index2) are not zero-based.
  • You may assume that each input would have exactly one solution and you may not use the same element twice.

Example:

Input: numbers = [2,7,11,15], target = 9
Output: [1,2]
Explanation: The sum of 2 and 7 is 9. Therefore index1 = 1, index2 = 2.

-----------------------------------------------------------------------------------------------------------------

1)

由于数组是已经排序好的,所以用二分查找,时间复杂度为O(nlogn)。就是先遍历数组,然后查找这个数的右边的是否有一个数,这个数与它相加得到目标数。

C++代码:

class Solution {
public:
    vector<int> twoSum(vector<int>& numbers, int target) {
        for(int i = 0;i < numbers.size(); i++){
            int t = target - numbers[i],left = i + 1,right = numbers.size() - 1;
            while(left <= right){
                int mid = left + (right - left)/2;
                if(numbers[mid] == t) return {i+1,mid+1};
                else if(numbers[mid] < t) left = mid + 1;
                else right = mid - 1;
            }
        }
        return {};
    }
};

 

2)

不过二分查找的时间复杂度比较大,可以用双指针,时间复杂度为线性。空间复杂度为O(1)。

C++代码:

class Solution {
public:
    vector<int> twoSum(vector<int>& numbers, int target) {
        int l = 0,r = numbers.size() - 1;
        while(l < r){
            if(numbers[l] + numbers[r] == target) return {l+1,r+1};
            else if(numbers[l] + numbers[r] > target) r--;
            else l++;
        }
        return {};
    }
};
posted @ 2019-04-28 18:26  PJCK  阅读(132)  评论(0编辑  收藏  举报